.\" $Id: xmogul.man,v 2.1 1996/07/11 20:56:22 deaven Exp deaven $
.\" xmogul: molecular graphics utility
.\"
.\" In the following, "you" and "You" refer to any entity other than 
.\" the Microsoft corporation and its subsidiaries.  All rights are
.\" reserved by the author in connection with Microsoft and its
.\" subsidiaries.  The Microsoft Network is explicity denied the right
.\" to copy, reproduce, or transmit this software.
.\"
.\"   This program is free software; you can redistribute it and/or modify
.\"   it under the terms of the GNU General Public License as published by
.\"   the Free Software Foundation; either version 2 of the License, or
.\"   (at your option) any later version.
.\"
.\"   This program is distributed in the hope that it will be useful,
.\"   but WITHOUT ANY WARRANTY; without even the implied warranty of
.\"   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
.\"   GNU General Public License for more details.
.\"
.\"   You should have received a copy of the GNU General Public License
.\"   along with this program; if not, write to the Free Software
.\"   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.\"
.TH MOGUL 1 "15 March 1996"
.SH NAME
xmogul \- render pictures of molecular geometries

.SH SYNOPSIS
.B xmogul
.BI "[\|\--init=" script "\|]"
.RB "[\|" \--noinit "\|]"
.BI "[\|\--device=" name "\|]"
.RB "[\|" \--movie "\|]"
.RB "[\|" \--help "\|]"
.RI "[\|" geometry "\|]"
.RI "[\|" X11-options "\|]"
.RB

.SH DESCRIPTION
.IX xmogul "" "\fLxmogul\fR \(em make pictures of molecular geometries."
.B xmogul
reads a molecular geometry specification and renders a picture on (by
default) an X terminal.
.B xmogul
is not too fancy, but can do realistic shading and
perspective views, and can create not too terribly huge PostScript
renditions of these views.  PostScript snapshots of the current view
may be made at any time. When used with
.B GhostScript,
.B xmogul
can also make frames in GIF, PPM or JPEG format. (These frames can be
compiled into MPEG movies with an appropriate encoder tool.)

.B xmogul
can  read  molecular geometries in any format supported by libdmd
(see geometry(5)).
If the input file is seekable,
.B xmogul
provides random access to any of the frames in the file by
using a scrollbar.

Finally,
.B xmogul
can operate without any X display, rendering frames of a movie in a
batch environment (see the
.B \--device
option below.)

.SH OPTIONS
.PP
.TP
.BI \--init= script
Read
.I script
instead of the default initialization script file ``.mogulrc''.
.I script
can be `-' to specify standard input.
The format of the initialization script is described below.
.B xmogul
will attempt to load the initialization script, 
or ``.mogulrc'', in the current directory
or in the path given by the environment variable MOGULPATH, after all
of the input options have been processed.  If no script can be found,
and the
.B \--noinit
option had not been given, 
.B xmogul
will load an internal default script.

.TP
.B \--noinit
Start up with a null initialization script.  This will prevent any
rendering, which might be useful for very large geometries if you
want to manually add groups of atoms to a computationally 
expensive rendering.

.TP
.BI \--device= name
Use the device described by
.I name
as the default device, instead of opening a window on an X terminal.
The possible values of 
.I name
depend on the devices that have been compiled into
.BR xmogul ,
and may be obtained by giving the 
.B \--help
option.
Additional device options may be appended to
.I name
as a colon-separated list.  See the device options section below for
more information about specific device options.
When an alternate device is chosen, a single frame of geometry data is
rendered on the device, unless the 
.B \--movie
option has been given, in which case all of the frames in the input
geometry file are rendered.

.TP
.BI \--movie
Render all of the frames in the input geometry.  This option does
nothing unless the 
.B \--device
option has been used to select an alternate default device.

.SH "INPUT DATA FORMAT"
.PP
.B xmogul 
can read molecular geometries in any format supported by libdmd
(see geometry(5)).

.SH "INITIALIZATION SCRIPT"
.PP
.B xmogul
use a very simple scripting language to describe features of a
molecular geometry plot.  The script is executed whenever a new
molecular geometry is loaded, either because a new geometry file was
opened or a new frame of the current geometry file was selected.

The script is line-oriented, with one command per line.  The commands
are not documented here yet.

.SH "WINDOW ACTIONS"
.PP
The  scrollbar  at  the bottom of 
.BR xmogul "'s"
window controls the frame within the current geometry file.  Buttons
are provided to rewind, play, stop, and fast forward. Clicking on
the left (right) mouse button within the scrollbar region steps by
a single frame forward (backward).  The scrollbar at the right
controls the zoom operation.  Press the `zero' button to reset the
zoom scale so that the reference position on the scrollbar represents the
current camera scale.

Within the main window, the left mouse button can be used to orbit the
currently displayed geometry, and 
the middle mouse button performs a panning operation, moving the
camera within the plane of the lens (the computer screen).  

.SH "DEVICE SPECIFIC OPTIONS"
.PP
Some of the alternate devices and the opions they support are listed
here for convenience.

.BR \--device= ps
The Postscript device.  All of the rendered
frames are collected together into
a single file. Options supported:
.TP
.RI file= filename
Write the Postscript file to
.IR filename .
.TP
.RI psize= "width" , "height"
Generate the plot in an area whose dimensions in millimeters are given
by
.I width
and
.IR height .
.TP
.RI plots_per_page= "N"
Put 
.I N
plots on each page (default 1).

.PP
.BR \--device= ppm "|" gif "|" jpeg
For the ``ppm'', ``gif'', and ``jpeg'' devices, each frame is
written to a file whose name contains the frame number.  By default,
the file names are 
.RI "``mogul." frame  . suffix "''"
where 
.I frame
is the frame number (starting at zero) in the inpout geometry file,
and
.I suffix
is chosen depending on the particular output format.
You can then run the Berkeley MPEG encoder (see mpeg_encode(1))
or a similar encoder in order to compile the frames into a single
MPEG video stream.
Options supported:
.TP
.RI file= filename
Write the final file to
.IR filename ,
substituting the frame number for each occurance of the string ``%f''
in
.IR filename .
.TP
.RI size= width x height
Generate a plot whose size in pixels is
.I width 
by 
.IR height .
.TP
.RI res= dpi
Generate a plot whose apprent resolution in pixels per inch is
.IR dpi .
.TP
.RB compress= yes "|" no
If 
.BR yes ,
use gzip(1) to compress each frame file.

.SH SEE ALSO
geotools(1), mpeg_encode(1), gs(1), geometry(5)

.SH BUGS
.PP
.TP
This application has some rough edges.  Among them are

Error messages are not collected for display in a window; many simply
get printed to stderr.

Communication with the window manager is not implemented yet.

.PP
The shading modes are handled at the device level,
using algorithms which may be strictly valid only for non-perspective
viewer transformations.  Highly ``perspectived'' views will therefore
have the annoying error that the atoms look suspicisously like flat
disks instead of spheres.  Also, since the algorithm is device-specific,
X11 previews may not be identical to a rendering of the same view.

Although the PostScript output is not huge in size, the time it takes
to interprept the PostScript might be unbearably long on an older
printer if solid atoms are rendered.

.B xmogul
is not in any way related to Project Mogul, a
top secret NYU program to detect Soviet a-bomb tests using long-range
balloons, that the Air Force claims is to blame for
the 1947 ``Roswell Incident.''

.SH AUTHOR
.PP
.B xmogul
was written by David Deaven while at the Pennsylvania State
University, 1987.  It was then dredged up in 1992 at the University of
California, Berkeley, and hacked into a form suitable for plotting
a few figures in a Ph.D. thesis.  Finally, it was refined at Ames
Laboratory, USDOE, by David Deaven <deaven@ishmael.ameslab.gov>.
The present code is (c)1994,1995,1996 David Deaven.
PostScript(tm) is a registered trademark of Adobe Systems Inc.
